from language import HTMLAttribute, HTMLTag, HTMLTagAttributeType


Tags = [
    HTMLTag('a', self_closing=False),
    HTMLTag('abbr', self_closing=False),
    HTMLTag('acronym', self_closing=False),
    HTMLTag('address', self_closing=False),
    HTMLTag('applet', self_closing=False),
    HTMLTag('area', self_closing=True),
    HTMLTag('article', self_closing=False),
    HTMLTag('aside', self_closing=False),
    HTMLTag('audio', self_closing=False),
    HTMLTag('b', self_closing=False),
    HTMLTag('base', self_closing=True),
    HTMLTag('basefont', self_closing=False),
    HTMLTag('bdi', self_closing=False),
    HTMLTag('bdo', self_closing=False),
    HTMLTag('big', self_closing=False),
    HTMLTag('blockquote', self_closing=False),
    HTMLTag('body', self_closing=False),
    HTMLTag('button', self_closing=False),
    HTMLTag('canvas', self_closing=False),
    HTMLTag('caption', self_closing=False),
    HTMLTag('center', self_closing=False),
    HTMLTag('cite', self_closing=False),
    HTMLTag('code', self_closing=False),
    HTMLTag('col', self_closing=True),
    HTMLTag('colgroup', self_closing=False),
    HTMLTag('data', self_closing=False),
    HTMLTag('datalist', self_closing=False),
    HTMLTag('dd', self_closing=False),
    HTMLTag('del', self_closing=False),
    HTMLTag('details', self_closing=False),
    HTMLTag('dfn', self_closing=False),
    HTMLTag('dialog', self_closing=False),
    HTMLTag('dir', self_closing=False),
    HTMLTag('div', self_closing=False),
    HTMLTag('dl', self_closing=False),
    HTMLTag('dt', self_closing=False),
    HTMLTag('em', self_closing=False),
    HTMLTag('embed', self_closing=True),
    HTMLTag('fieldset', self_closing=False),
    HTMLTag('figcaption', self_closing=False),
    HTMLTag('figure', self_closing=False),
    HTMLTag('font', self_closing=False),
    HTMLTag('footer', self_closing=False),
    HTMLTag('form', self_closing=False),
    HTMLTag('frame', self_closing=True),
    HTMLTag('frameset', self_closing=False),
    HTMLTag('h1', self_closing=False),
    HTMLTag('h2', self_closing=False),
    HTMLTag('h3', self_closing=False),
    HTMLTag('h4', self_closing=False),
    HTMLTag('h5', self_closing=False),
    HTMLTag('h6', self_closing=False),
    HTMLTag('head', self_closing=False),
    HTMLTag('header', self_closing=False),
    HTMLTag('hr', self_closing=True),
    HTMLTag('html', self_closing=False),
    HTMLTag('i', self_closing=False),
    HTMLTag('iframe', self_closing=False),
    HTMLTag('img', self_closing=True),
    HTMLTag('input', self_closing=True),
    HTMLTag('ins', self_closing=False),
    HTMLTag('kbd', self_closing=False),
    HTMLTag('label', self_closing=False),
    HTMLTag('legend', self_closing=False),
    HTMLTag('li', self_closing=False),
    HTMLTag('link', self_closing=True),
    HTMLTag('main', self_closing=False),
    HTMLTag('map', self_closing=False),
    HTMLTag('mark', self_closing=False),
    HTMLTag('meta', self_closing=True),
    HTMLTag('meter', self_closing=False),
    HTMLTag('nav', self_closing=False),
    HTMLTag('noframes', self_closing=False),
    HTMLTag('noscript', self_closing=False),
    HTMLTag('object', self_closing=False),
    HTMLTag('ol', self_closing=False),
    HTMLTag('optgroup', self_closing=False),
    HTMLTag('option', self_closing=False),
    HTMLTag('output', self_closing=False),
    HTMLTag('p', self_closing=False),
    HTMLTag('param', self_closing=True),
    HTMLTag('picture', self_closing=False),
    HTMLTag('pre', self_closing=False),
    HTMLTag('progress', self_closing=False),
    HTMLTag('q', self_closing=False),
    HTMLTag('s', self_closing=False),
    HTMLTag('samp', self_closing=False),
    HTMLTag('script', self_closing=False),
    HTMLTag('select', self_closing=False),
    HTMLTag('small', self_closing=False),
    HTMLTag('source', self_closing=True),
    HTMLTag('span', self_closing=False),
    HTMLTag('strike', self_closing=False),
    HTMLTag('strong', self_closing=False),
    HTMLTag('style', self_closing=False),
    HTMLTag('sub', self_closing=False),
    HTMLTag('sup', self_closing=False),
    HTMLTag('svg', self_closing=False),
    HTMLTag('table', self_closing=False),
    HTMLTag('tbody', self_closing=False),
    HTMLTag('td', self_closing=False),
    HTMLTag('template', self_closing=False),
    HTMLTag('textarea', self_closing=False),
    HTMLTag('tfoot', self_closing=False),
    HTMLTag('th', self_closing=False),
    HTMLTag('thead', self_closing=False),
    HTMLTag('time', self_closing=False),
    HTMLTag('title', self_closing=False),
    HTMLTag('tr', self_closing=False),
    HTMLTag('track', self_closing=True),
    HTMLTag('tt', self_closing=False),
    HTMLTag('u', self_closing=False),
    HTMLTag('ul', self_closing=False),
    HTMLTag('var', self_closing=False),
    HTMLTag('video', self_closing=False),
    HTMLTag('wbr', self_closing=True),
    HTMLTag('xmp', self_closing=False),
]

EventsAttributes = [
    HTMLAttribute('onafterprint', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onafterscriptexecute', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onanimationcancel', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onanimationend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onanimationiteration', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onanimationstart', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onauxclick', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbeforecopy', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbeforecut', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbeforeinput', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbeforeprint', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbeforescriptexecute', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbeforetoggle', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbeforeunload', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbegin', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onblur', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onbounce', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oncanplay', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oncanplaythrough', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onchange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onclick', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onclose', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oncontextmenu', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oncopy', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oncuechange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oncut', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondblclick', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondrag', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondragend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondragenter', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondragleave', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondragover', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondragstart', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondrop', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ondurationchange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onended', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onerror', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onfinish', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onfocus', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onfocusin', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onfocusout', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onfullscreenchange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onhashchange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oninput', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('oninvalid', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onkeydown', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onkeypress', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onkeyup', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onload', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onloadeddata', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onloadedmetadata', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmessage', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmousedown', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmouseenter', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmouseleave', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmousemove', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmouseout', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmouseover', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmouseup', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmousewheel', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onmozfullscreenchange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpagehide', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpageshow', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpaste', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpause', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onplay', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onplaying', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointerdown', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointerenter', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointerleave', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointermove', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointerout', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointerover', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointerrawupdate', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpointerup', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onpopstate', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onprogress', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onratechange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onrepeat', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onreset', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onresize', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onscroll', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onscrollend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onsearch', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onseeked', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onseeking', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onselect', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onselectionchange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onselectstart', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onshow', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onstart', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onsubmit', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontimeupdate', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontoggle', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontouchend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontouchmove', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontouchstart', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontransitioncancel', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontransitionend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontransitionrun', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('ontransitionstart', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onunhandledrejection', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onunload', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onvolumechange', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onwebkitanimationend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onwebkitanimationiteration', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onwebkitanimationstart', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onwebkittransitionend', HTMLTagAttributeType.TypeJS),
    HTMLAttribute('onwheel', HTMLTagAttributeType.TypeJS),
]

GlobalAttributes = [
    HTMLAttribute('accesskey', HTMLTagAttributeType.TypeAccessKey),
    HTMLAttribute('autofocus', HTMLTagAttributeType.TypeFlag),
    HTMLAttribute('autocomplete', HTMLTagAttributeType.TypeFlag),
    HTMLAttribute('autocapitalize', HTMLTagAttributeType.TypeFlag),
    HTMLAttribute('contenteditable', HTMLTagAttributeType.TypeBoolean),
    HTMLAttribute('contextmenu', HTMLTagAttributeType.TypeText),
    HTMLAttribute('dir', HTMLTagAttributeType.TypeDir),
    HTMLAttribute('draggable', HTMLTagAttributeType.TypeBoolean),
    HTMLAttribute('dropzone', HTMLTagAttributeType.TypeDrop),
    HTMLAttribute('hidden', HTMLTagAttributeType.TypeFlag),
    HTMLAttribute('is', HTMLTagAttributeType.TypeText),
    HTMLAttribute('lang', HTMLTagAttributeType.TypeText),
    HTMLAttribute('popover', HTMLTagAttributeType.TypeFlag),
    HTMLAttribute('slot', HTMLTagAttributeType.TypeName),
    HTMLAttribute('spellcheck', HTMLTagAttributeType.TypeBoolean),
    HTMLAttribute('style', HTMLTagAttributeType.TypeStlye),
    HTMLAttribute('tabindex', HTMLTagAttributeType.TypeNumber),
    HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    HTMLAttribute('translate', HTMLTagAttributeType.TypeBoolean),
]

TagSpecificAttributes = {
    'a': [
        HTMLAttribute('download', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('href', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('hreflang', HTMLTagAttributeType.TypeText),
        HTMLAttribute('media', HTMLTagAttributeType.TypeText),
        HTMLAttribute('ping', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('referrerpolicy', HTMLTagAttributeType.TypeText),
        HTMLAttribute('rel', HTMLTagAttributeType.TypeText),
        HTMLAttribute('target', HTMLTagAttributeType.TypeWindowTarget),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],
    'abbr': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'acronym': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'address': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'applet': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('alt', HTMLTagAttributeType.TypeText),
        HTMLAttribute('archive', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('code', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('codebase', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('data', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('hspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('object', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('vspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'area': [
        HTMLAttribute('alt', HTMLTagAttributeType.TypeText),
        HTMLAttribute('coords', HTMLTagAttributeType.TypeText),
        HTMLAttribute('download', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('href', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('hreflang', HTMLTagAttributeType.TypeText),
        HTMLAttribute('media', HTMLTagAttributeType.TypeText),
        HTMLAttribute('ping', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('referrerpolicy', HTMLTagAttributeType.TypeText),
        HTMLAttribute('rel', HTMLTagAttributeType.TypeText),
        HTMLAttribute('shape', HTMLTagAttributeType.TypeText),
        HTMLAttribute('target', HTMLTagAttributeType.TypeWindowTarget),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],
    'article': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'aside': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'audio': [
        HTMLAttribute('autoplay', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('controls', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('loop', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('muted', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('preload', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
    ],
    'b': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'base': [
        HTMLAttribute('href', HTMLTagAttributeType.TypeURL),
    ],
    'basefont': [
        HTMLAttribute('color', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('face', HTMLTagAttributeType.TypeText),
        HTMLAttribute('size', HTMLTagAttributeType.TypeNumber),
    ],
    'bdi': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'bdo': [
        HTMLAttribute('dir', HTMLTagAttributeType.TypeDir),
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'big': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'blockquote': [
        HTMLAttribute('cite', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'body': [
        HTMLAttribute('alink', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('background', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('link', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('text', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('vlink', HTMLTagAttributeType.TypeColor),
    ],
    'button': [
        HTMLAttribute('autofocus', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('form', HTMLTagAttributeType.TypeName),
        HTMLAttribute('formaction', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('formenctype', HTMLTagAttributeType.TypeText),
        HTMLAttribute('formmethod', HTMLTagAttributeType.TypeText),
        HTMLAttribute('formnovalidate', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('formtarget', HTMLTagAttributeType.TypeWindowTarget),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
        HTMLAttribute('value', HTMLTagAttributeType.TypeText),
        HTMLAttribute('popovertarget', HTMLTagAttributeType.TypeTarget),
    ],
    'canvas': [
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'caption': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'center': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'cite': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'code': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'col': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('span', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'colgroup': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('span', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'data': [
        HTMLAttribute('value', HTMLTagAttributeType.TypeText),
    ],
    'datalist': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'dd': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'del': [
        HTMLAttribute('cite', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('datetime', HTMLTagAttributeType.TypeDate),
    ],
    'details': [
        HTMLAttribute('open', HTMLTagAttributeType.TypeFlag),
    ],
    'dfn': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'dialog': [
        HTMLAttribute('open', HTMLTagAttributeType.TypeFlag),
    ],
    'dir': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'div': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'dl': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'dt': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'em': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'embed': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('hspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
        HTMLAttribute('vspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'fieldset': [
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('form', HTMLTagAttributeType.TypeName),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
    ],
    'figcaption': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'figure': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'font': [
        HTMLAttribute('color', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('face', HTMLTagAttributeType.TypeText),
        HTMLAttribute('size', HTMLTagAttributeType.TypeNumber),
    ],
    'footer': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'form': [
        HTMLAttribute('accept-charset', HTMLTagAttributeType.TypeText),
        HTMLAttribute('action', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('autocomplete', HTMLTagAttributeType.TypeText),
        HTMLAttribute('enctype', HTMLTagAttributeType.TypeText),
        HTMLAttribute('method', HTMLTagAttributeType.TypeText),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('novalidate', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('target', HTMLTagAttributeType.TypeWindowTarget),
    ],
    'frame': [
        HTMLAttribute('frameborder', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('marginheight', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('marginwidth', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('noresize', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('scrolling', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
    ],
    'frameset': [
        HTMLAttribute('cols', HTMLTagAttributeType.TypeText),
        HTMLAttribute('rows', HTMLTagAttributeType.TypeText),
    ],
    'h1': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'h2': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'h3': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'h4': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'h5': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'h6': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'head': [
        HTMLAttribute('profile', HTMLTagAttributeType.TypeURL),
    ],
    'header': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'hr': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('color', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('noshade', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('size', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'html': [
        HTMLAttribute('manifest', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('xmlns', HTMLTagAttributeType.TypeURL),
    ],
    'i': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'iframe': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('allow', HTMLTagAttributeType.TypeText),
        HTMLAttribute('allowfullscreen', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('allowpaymentrequest', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('allowusermedia', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('csp', HTMLTagAttributeType.TypeText),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('importance', HTMLTagAttributeType.TypeText),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('referrerpolicy', HTMLTagAttributeType.TypeText),
        HTMLAttribute('sandbox', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('srcdoc', HTMLTagAttributeType.TypeText),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'img': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('alt', HTMLTagAttributeType.TypeText),
        HTMLAttribute('border', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('crossorigin', HTMLTagAttributeType.TypeText),
        HTMLAttribute('decoding', HTMLTagAttributeType.TypeText),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('hspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('intrinsicsize', HTMLTagAttributeType.TypeText),
        HTMLAttribute('ismap', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('loading', HTMLTagAttributeType.TypeText),
        HTMLAttribute('longdesc', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('referrerpolicy', HTMLTagAttributeType.TypeText),
        HTMLAttribute('sizes', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('srcset', HTMLTagAttributeType.TypeText),
        HTMLAttribute('usemap', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('vspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'input': [
        HTMLAttribute('accept', HTMLTagAttributeType.TypeText),
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('alt', HTMLTagAttributeType.TypeText),
        HTMLAttribute('autocomplete', HTMLTagAttributeType.TypeText),
        HTMLAttribute('autofocus', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('capture', HTMLTagAttributeType.TypeText),
        HTMLAttribute('checked', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('dirname', HTMLTagAttributeType.TypeText),
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('form', HTMLTagAttributeType.TypeName),
        HTMLAttribute('formaction', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('formenctype', HTMLTagAttributeType.TypeText),
        HTMLAttribute('formmethod', HTMLTagAttributeType.TypeText),
        HTMLAttribute('formnovalidate', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('formtarget', HTMLTagAttributeType.TypeWindowTarget),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('inputmode', HTMLTagAttributeType.TypeText),
        HTMLAttribute('ismap', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('list', HTMLTagAttributeType.TypeName),
        HTMLAttribute('max', HTMLTagAttributeType.TypeText),
        HTMLAttribute('maxlength', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('min', HTMLTagAttributeType.TypeText),
        HTMLAttribute('minlength', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('multiple', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('pattern', HTMLTagAttributeType.TypeText),
        HTMLAttribute('placeholder', HTMLTagAttributeType.TypeText),
        HTMLAttribute('readonly', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('required', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('size', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('step', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
        HTMLAttribute('value', HTMLTagAttributeType.TypeText),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],

    'ins': [
        HTMLAttribute('cite', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('datetime', HTMLTagAttributeType.TypeDate),
    ],
    'kbd': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'label': [
        HTMLAttribute('for', HTMLTagAttributeType.TypeName),
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'legend': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'li': [
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
        HTMLAttribute('value', HTMLTagAttributeType.TypeNumber),
    ],
    'link': [
        HTMLAttribute('as', HTMLTagAttributeType.TypeText),
        HTMLAttribute('crossorigin', HTMLTagAttributeType.TypeText),
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('href', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('hreflang', HTMLTagAttributeType.TypeText),
        HTMLAttribute('integrity', HTMLTagAttributeType.TypeText),
        HTMLAttribute('media', HTMLTagAttributeType.TypeText),
        HTMLAttribute('referrerpolicy', HTMLTagAttributeType.TypeText),
        HTMLAttribute('rel', HTMLTagAttributeType.TypeText),
        HTMLAttribute('sizes', HTMLTagAttributeType.TypeText),
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],
    'main': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'map': [
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
    ],
    'mark': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'marquee': [
        HTMLAttribute('behavior', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('direction', HTMLTagAttributeType.TypeText),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('hspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('loop', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('scrollamount', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('scrolldelay', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('truespeed', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('vspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'menu': [
        HTMLAttribute('compact', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'meta': [
        HTMLAttribute('charset', HTMLTagAttributeType.TypeText),
        HTMLAttribute('content', HTMLTagAttributeType.TypeText),
        HTMLAttribute('http-equiv', HTMLTagAttributeType.TypeText),
        HTMLAttribute('name', HTMLTagAttributeType.TypeText),
    ],
    'meter': [
        HTMLAttribute('high', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('low', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('max', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('min', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('optimum', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('value', HTMLTagAttributeType.TypeNumber),
    ],
    'nav': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'noframes': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'noscript': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'object': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('archive', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('border', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('classid', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('code', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('codebase', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('codetype', HTMLTagAttributeType.TypeText),
        HTMLAttribute('data', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('declare', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('form', HTMLTagAttributeType.TypeName),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('hspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('standby', HTMLTagAttributeType.TypeText),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
        HTMLAttribute('usemap', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('vspace', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],

    'ol': [
        HTMLAttribute('compact', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('reversed', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('start', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],

    'optgroup': [
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('label', HTMLTagAttributeType.TypeText),
    ],
    'option': [
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('label', HTMLTagAttributeType.TypeText),
        HTMLAttribute('selected', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('value', HTMLTagAttributeType.TypeText),
    ],
    'output': [
        HTMLAttribute('for', HTMLTagAttributeType.TypeName),
        HTMLAttribute('form', HTMLTagAttributeType.TypeName),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
    ],
    'p': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
    ],
    'param': [
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
        HTMLAttribute('value', HTMLTagAttributeType.TypeText),
        HTMLAttribute('valuetype', HTMLTagAttributeType.TypeText),
    ],
    'picture': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'plaintext': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'pre': [
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'progress': [
        HTMLAttribute('max', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('value', HTMLTagAttributeType.TypeNumber),
    ],
    'q': [
        HTMLAttribute('cite', HTMLTagAttributeType.TypeURL),
    ],
    's': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'samp': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'script': [
        HTMLAttribute('async', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('charset', HTMLTagAttributeType.TypeText),
        HTMLAttribute('defer', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('integrity', HTMLTagAttributeType.TypeText),
        HTMLAttribute('language', HTMLTagAttributeType.TypeText),
        HTMLAttribute('nomodule', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('nonce', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],
    'select': [
        HTMLAttribute('autocomplete', HTMLTagAttributeType.TypeText),
        HTMLAttribute('autofocus', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('form', HTMLTagAttributeType.TypeName),
        HTMLAttribute('multiple', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('required', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('size', HTMLTagAttributeType.TypeNumber),
    ],
    'small': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'source': [
        HTMLAttribute('media', HTMLTagAttributeType.TypeText),
        HTMLAttribute('sizes', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('srcset', HTMLTagAttributeType.TypeText),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],
    'span': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'strike': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'strong': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'style': [
        HTMLAttribute('media', HTMLTagAttributeType.TypeText),
        HTMLAttribute('nonce', HTMLTagAttributeType.TypeText),
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],
    'sub': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'sup': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'table': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('border', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('cellpadding', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('cellspacing', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('frame', HTMLTagAttributeType.TypeText),
        HTMLAttribute('rules', HTMLTagAttributeType.TypeText),
        HTMLAttribute('summary', HTMLTagAttributeType.TypeText),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'tbody': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
    ],

    'td': [
        HTMLAttribute('abbr', HTMLTagAttributeType.TypeText),
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('axis', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('colspan', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('headers', HTMLTagAttributeType.TypeText),
        HTMLAttribute('height', HTMLTagAttributeType.TypeText),
        HTMLAttribute('nowrap', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('rowspan', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('scope', HTMLTagAttributeType.TypeText),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],
    'template': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'textarea': [
        HTMLAttribute('autocomplete', HTMLTagAttributeType.TypeText),
        HTMLAttribute('autofocus', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('cols', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('dirname', HTMLTagAttributeType.TypeText),
        HTMLAttribute('disabled', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('form', HTMLTagAttributeType.TypeName),
        HTMLAttribute('maxlength', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('minlength', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('name', HTMLTagAttributeType.TypeName),
        HTMLAttribute('placeholder', HTMLTagAttributeType.TypeText),
        HTMLAttribute('readonly', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('required', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('rows', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('wrap', HTMLTagAttributeType.TypeText),
    ],
    'tfoot': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
    ],
    'th': [
        HTMLAttribute('abbr', HTMLTagAttributeType.TypeText),
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('axis', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('colspan', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('headers', HTMLTagAttributeType.TypeText),
        HTMLAttribute('height', HTMLTagAttributeType.TypeText),
        HTMLAttribute('nowrap', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('rowspan', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('scope', HTMLTagAttributeType.TypeText),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],

    'thead': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
    ],
    'time': [
        HTMLAttribute('datetime', HTMLTagAttributeType.TypeDate),
    ],
    'title': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'tr': [
        HTMLAttribute('align', HTMLTagAttributeType.TypeText),
        HTMLAttribute('bgcolor', HTMLTagAttributeType.TypeColor),
        HTMLAttribute('char', HTMLTagAttributeType.TypeText),
        HTMLAttribute('charoff', HTMLTagAttributeType.TypeText),
        HTMLAttribute('valign', HTMLTagAttributeType.TypeText),
    ],
    'track': [
        HTMLAttribute('default', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('kind', HTMLTagAttributeType.TypeText),
        HTMLAttribute('label', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('srclang', HTMLTagAttributeType.TypeText),
    ],
    'tt': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'u': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'ul': [
        HTMLAttribute('compact', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('type', HTMLTagAttributeType.TypeText),
    ],
    'var': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'video': [
        HTMLAttribute('autoplay', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('controls', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('crossorigin', HTMLTagAttributeType.TypeText),
        HTMLAttribute('height', HTMLTagAttributeType.TypeNumber),
        HTMLAttribute('loop', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('muted', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('playsinline', HTMLTagAttributeType.TypeFlag),
        HTMLAttribute('poster', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('preload', HTMLTagAttributeType.TypeText),
        HTMLAttribute('src', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('width', HTMLTagAttributeType.TypeNumber),
    ],

    'wbr': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'xmp': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'xml': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'xsl': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
    ],
    'svg': [
        HTMLAttribute('title', HTMLTagAttributeType.TypeText),
        HTMLAttribute('xmlns', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('xmlns:xlink', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('xmlns:xml', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('xmlns:xsl', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('xmlns:xhtml', HTMLTagAttributeType.TypeURL),
        HTMLAttribute('xmlns:ev', HTMLTagAttributeType.TypeURL),
    ],
}
